//+------------------------------------------------------------------+
//|                                   UniZigZagChannel_v1.8 600+.mq4 |
//|                                Copyright  2014, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LightPink
#property indicator_color2 LightBlue
#property indicator_color3 Coral
#property indicator_color4 CornflowerBlue
#property indicator_color5 Turquoise
#property indicator_color6 Tomato
#property indicator_color7 Orange
#property indicator_color8 OliveDrab

#property indicator_width1 0
#property indicator_width2 0
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2
#property indicator_style7 2
#property indicator_style8 2


//---- input parameters
extern int     TimeFrame            =    0;    //TimeFrame in min
extern int     UpBandPrice          =    0;    //Upper Band Price(0...6)
extern int     LoBandPrice          =    0;    //Lower Band Price(0...6) 
extern double  ReversalValue        =   12;    //Reversal Value according to Retrace Method
extern int     RetraceMethod        =    0;    //Retrace Method: 0-channel,1-% of Price,2-Price Change in pips,3-Ratio of ATR
extern int     ATRperiod            =   50;    //ATR period (RetraceMethod=3)
extern int     SignalMode           =    1;    //0-off,1-on
extern int     ZigZagMode           =    1;    //0-off,1-on
extern int     ZigZagChannelMode    =    1;    //0-off,1-by High/Low,2-Chaos Bands  
extern int     PriceChannelMode     =    1;    //0-off,1-on 

extern int     AlertMode            =    0;    //0-off,1-on 
extern int     SoundsNumber         =    5;    //Number of sounds after Signal
extern int     SoundsPause          =    5;    //Pause in sec between sounds 
extern string  UpSound              = "alert.wav";
extern string  DnSound              = "alert2.wav";
extern int     EmailMode            =    0;    //0-off,1-on 
extern int     EmailsNumber         =    1;    //Number of emails after Signal



double upZZ1[];
double dnZZ1[];  
double hiBuffer[];
double loBuffer[];
double upSignal[];
double dnSignal[];
double hiband[];
double loband[];

int      trend[][3];  
datetime hiTime[][2], loTime[][2], prevtime[], preTime, ptime;
double   period[1], upBand[][2], loBand[][2], hiValue[][2], loValue[][2], _point;
string   short_name, TF, IndicatorName, prevmess, prevemail;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   if(TimeFrame <= Period()) TimeFrame = Period();
   TF = tf(TimeFrame);
   if(TF  == "Unknown timeframe") TimeFrame = Period();
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
   IndicatorName = WindowExpertName();
     
   period[0] = ReversalValue;
      
   SetIndexBuffer(0,   upZZ1); SetIndexStyle(0,DRAW_ZIGZAG);
   SetIndexBuffer(1,   dnZZ1); SetIndexStyle(1,DRAW_ZIGZAG);
   SetIndexBuffer(2,hiBuffer); SetIndexStyle(2,  DRAW_LINE); 
   SetIndexBuffer(3,loBuffer); SetIndexStyle(3,  DRAW_LINE); 
   SetIndexBuffer(4,upSignal); SetIndexStyle(4, DRAW_ARROW); SetIndexArrow(4,159);
   SetIndexBuffer(5,dnSignal); SetIndexStyle(5, DRAW_ARROW); SetIndexArrow(5,159);
   SetIndexBuffer(6,  hiband); if(PriceChannelMode > 0) SetIndexStyle(6,DRAW_LINE); else SetIndexStyle(6,DRAW_NONE); 
   SetIndexBuffer(7,  loband); if(PriceChannelMode > 0) SetIndexStyle(7,DRAW_LINE); else SetIndexStyle(7,DRAW_NONE);   
   
   short_name = IndicatorName+"[" + TF + "]("+UpBandPrice+","+LoBandPrice+","+DoubleToStr(ReversalValue,1)+","+RetraceMethod+")";
   IndicatorShortName(short_name);
   
   SetIndexLabel(0,"Upper ZigZag"); SetIndexEmptyValue(0,0.0);
   SetIndexLabel(1,"Lower ZigZag"); SetIndexEmptyValue(1,0.0);   
   SetIndexLabel(2,"UniZigZag Upper Band"); 
   SetIndexLabel(3,"UniZigZag Lower Band");
   SetIndexLabel(4,"UpSignal"); 
   SetIndexLabel(5,"DnSignal");
   SetIndexLabel(6,"Channel\'s Upper Band"); 
   SetIndexLabel(7,"Channel\'s Lower Band");
      
//---- 
   int draw_begin = Bars - iBars(NULL,TimeFrame)*TimeFrame/Period() + MathMax(ReversalValue,ATRperiod);
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
   SetIndexDrawBegin(2,draw_begin);
   SetIndexDrawBegin(3,draw_begin);
   SetIndexDrawBegin(4,draw_begin);
   SetIndexDrawBegin(5,draw_begin);
   SetIndexDrawBegin(6,draw_begin);
   SetIndexDrawBegin(7,draw_begin);
   
   
   ArrayResize(prevtime,1);
   ArrayResize(   trend,1);
   ArrayResize(  hiTime,1);
   ArrayResize(  loTime,1);
   ArrayResize(  upBand,1);
   ArrayResize(  loBand,1);
   ArrayResize( hiValue,1);
   ArrayResize( loValue,1);
   
   _point   = MarketInfo(Symbol(),MODE_POINT)*MathPow(10,Digits%2);
   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() { Comment(""); return(0);}
//+------------------------------------------------------------------+
//| UniZigZagChannel_v1.8                                            |
//+------------------------------------------------------------------+
int start()
{
   int i,shift, counted_bars=IndicatorCounted(),limit;
   
   if (counted_bars > 0) limit = Bars - counted_bars - 1;     
   if (counted_bars < 1) 
   {
   limit=Bars-1;    
      for(i=0;i<limit;i++)
      { 
      upZZ1[i]    = 0;
      dnZZ1[i]    = 0;
      hiBuffer[i] = 0;
      loBuffer[i] = 0;
      upSignal[i] = 0;
      dnSignal[i] = 0;
      hiband[i]   = 0;
      loband[i]   = 0;
      }
         
   SetIndexDrawBegin(0,period[0]);
   }
   	
   if(TimeFrame != Period())
	{
   
   int pivotshift = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                            ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,0,
                            AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,6,0);      
    
   limit = MathMax(limit,MathMax(pivotshift+1,1)*TimeFrame/Period());   
   
   
      for(shift = 0;shift < limit;shift++) 
      {	
      int y = iBarShift(NULL,TimeFrame,Time[shift]);
      
      double upzz = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                            ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                            AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,0,y);   
      
      double dnzz = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                            ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                            AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,1,y);   
      
      datetime time = iTime(NULL,TimeFrame,y);
      upZZ1[shift] = 0;
      dnZZ1[shift] = 0;   
                  
         if(time == Time[shift])
         {
         int mtfshift = iBarShift(NULL,0,time);    
         
            if(upzz > 0)
            {
            datetime uptime = time; 
                      
            if(y > 0) int uplen = mtfshift - iBarShift(NULL,0,iTime(NULL,TimeFrame,y-1))+1; 
            else uplen = mtfshift+1;
                        
            int upshift = 0;
            double maxvalue = 0;   
            
               for(i=0;i<uplen;i++)
               { 
               double upvalue = iMA(NULL,0,1,0,0,UpBandPrice,shift-i);   
               if(upvalue > maxvalue) {maxvalue = upvalue; upshift = i;}
               }
   
            upZZ1[mtfshift-upshift] = upzz; 
            }
      
            if(dnzz > 0)
            {
            datetime dntime = time; 
                      
            if(y > 0) int dnlen = mtfshift - iBarShift(NULL,0,iTime(NULL,TimeFrame,y-1))+1; 
            else dnlen = mtfshift+1;
           
            int dnshift = 0;
            double minvalue = 10000000;   
            
               for(i=0;i<dnlen;i++)
               { 
               double dnvalue = iMA(NULL,0,1,0,0,LoBandPrice,shift-i);   
               if(dnvalue < minvalue) {minvalue = dnvalue; dnshift = i;}
               }
      
            dnZZ1[mtfshift-dnshift] = dnzz; 
            if(y == 0) Print("time=",TimeToStr(iTime(NULL,TimeFrame,y))," dnzz=",dnZZ1[mtfshift-dnshift]); 
            }
         }
      
      hiBuffer[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                                ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                                AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,2,y);   
      
      loBuffer[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                                ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                                AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,3,y);        
      
      hiband[shift]   = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                                ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                                AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,6,y);       
      
      loband[shift]   = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                                ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                                AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,7,y);         
         
         if(SignalMode > 0)
         {
         upSignal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                                   ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                                   AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,4,y);         
         
         dnSignal[shift] = iCustom(NULL,TimeFrame,IndicatorName,0,UpBandPrice,LoBandPrice,ReversalValue,RetraceMethod,
                                   ATRperiod,SignalMode,ZigZagMode,ZigZagChannelMode,PriceChannelMode,
                                   AlertMode,SoundsNumber,SoundsPause,UpSound,DnSound,EmailMode,EmailsNumber,5,y);         
         }
      }
      
         
   return(0);
   }
   else 
   if(period[0] > 0) _uniZigZag(upZZ1,dnZZ1,0,period[0],limit,counted_bars);
        
   return(0);   
}

void _uniZigZag(double& upZZ[],double& dnZZ[],int index,double retrace,int limit,int counted_bars)
{
   int i, nlow, nhigh;
   double hi, lo;
   
   
   for(int shift=limit;shift>=0;shift--) 
   {	
      if(prevtime[index] != Time[shift])
      {
      hiTime[index][1]  = hiTime[index][0];
      loTime[index][1]  = loTime[index][0];
      upBand[index][1]  = upBand[index][0];
      loBand[index][1]  = loBand[index][0];
      hiValue[index][1] = hiValue[index][0];
      loValue[index][1] = loValue[index][0];
      trend[index][2]   = trend[index][1];
      trend[index][1]   = trend[index][0];
      prevtime[index]   = Time[shift];
      }
               
      if(shift < Bars - retrace)
      {
      hiTime[index][0]  = hiTime[index][1];
      loTime[index][0]  = loTime[index][1];
      upBand[index][0]  = upBand[index][1];
      loBand[index][0]  = loBand[index][1];   
      hiValue[index][0] = 0;
      loValue[index][0] = 0;   
      trend[index][0]   = trend[index][1];
      
      hi  = iMA(NULL,0,1,0,0,UpBandPrice,shift); 
      lo  = iMA(NULL,0,1,0,0,LoBandPrice,shift);            
          
         
         switch(RetraceMethod)
         {
         case 0: upBand[index][0] = iMA(NULL,0,1,0,0,UpBandPrice,HighestBar(retrace,shift,0)); //iHighest(NULL,0,UpBandPrice,retrace,shift));
                 loBand[index][0] = iMA(NULL,0,1,0,0,LoBandPrice, LowestBar(retrace,shift,0)); //iLowest (NULL,0,LoBandPrice,retrace,shift)); 
                 break;
         
         case 1: if(hi > upBand[index][0])   
                 {
                 upBand[index][0] = hi;
                 loBand[index][0] = upBand[index][0] * (1-0.01*retrace); 
                 }
                 
                 if(lo < loBand[index][0])  
                 {
                 loBand[index][0] = lo;
                 upBand[index][0] = loBand[index][0] * (1+0.01*retrace); 
                 }
                 break;
         
         case 2: if(hi >= upBand[index][0])   
                 {
                 upBand[index][0] = hi;
                 loBand[index][0] = upBand[index][0] - retrace *_point; 
                 }
                 
                 if(lo <= loBand[index][0])  
                 {
                 loBand[index][0] = lo;
                 upBand[index][0] = loBand[index][0] + retrace *_point; 
                 }
                 break;
                     
         case 3: double atr = iATR(NULL,0,ATRperiod,shift);
                 
                 if(hi >= upBand[index][0])   
                 {
                 upBand[index][0] = hi;
                 loBand[index][0] = upBand[index][0] - retrace * atr; 
                 }
                 
                 if(lo <= loBand[index][0])  
                 {
                 loBand[index][0] = lo;
                 upBand[index][0] = loBand[index][0] + retrace * atr; 
                 }
                 break;        
         }
         
         upSignal[shift] = 0;
         dnSignal[shift] = 0;
         
         if(PriceChannelMode > 0)
         {  
         hiband[shift] = upBand[index][0];
         loband[shift] = loBand[index][0];
         }
         
         if(lo < loBand[index][1] && (hi <= upBand[index][1] ||(hi > upBand[index][1] && Close[shift] < Close[shift+1])) && trend[index][0] >= 0 && loBand[index][1] > 0) 
         {
         trend[index][0] =-1; 
         
         int hibar = HighestBar(iBarShift(NULL,0,loTime[index][0],FALSE)-shift,shift,1);
         
         hiValue[index][0] = iMA(NULL,0,1,0,0,UpBandPrice,hibar);
         hiTime[index][0]  = Time[hibar];
         if(SignalMode > 0) dnSignal[shift] = hiValue[index][0];
         if(ZigZagMode > 0) upZZ[hibar] = hiValue[index][0]; 
         
         }
         
         if(hi > upBand[index][1] && (lo >= loBand[index][1] ||(lo < loBand[index][1] && Close[shift] > Close[shift+1])) && trend[index][0] <= 0 && upBand[index][1] > 0) 
         {
         trend[index][0] = 1; 
          
         int lobar = LowestBar(iBarShift(NULL,0,hiTime[index][0],FALSE) - shift,shift,1);
      
         loValue[index][0] = iMA(NULL,0,1,0,0,LoBandPrice,lobar);
         loTime[index][0] = Time[lobar];
         if(SignalMode > 0) upSignal[shift] = loValue[index][0];
         if(ZigZagMode > 0) dnZZ[lobar] = loValue[index][0];
         }   
         
         
         
         if(shift == 0)
         { 
         upZZ[shift] = 0;
         dnZZ[shift] = 0;  
            
            if(trend[index][0] > 0) 
            {
            int hilen = iBarShift(NULL,0,loTime[index][0],FALSE);
            nhigh = HighestBar(hilen,0,1);
            for (i=hilen;i>=0;i--) upZZ[i] = 0; 
            if(ZigZagMode > 0) upZZ[nhigh] = iMA(NULL,0,1,0,0,UpBandPrice,nhigh);
            if(PriceChannelMode == 0)  hiband[shift] = hilen;
            }   

            if(trend[index][0] < 0)
            { 
            int lolen = iBarShift(NULL,0,hiTime[index][0],FALSE);
            nlow = LowestBar(lolen,0,1);
            for (i=lolen;i>=0;i--) dnZZ[i] = 0; 
            if(ZigZagMode > 0) dnZZ[nlow] = iMA(NULL,0,1,0,0,LoBandPrice,nlow);
            if(PriceChannelMode == 0)  hiband[shift] = lolen;
            }
         }
      
         if(ZigZagChannelMode > 0)
         { 
         hiBuffer[shift] = hiBuffer[shift+1];
         loBuffer[shift] = loBuffer[shift+1];
       
         if(hiValue[index][0] > 0) hiBuffer[shift] = hiValue[index][0];
         if(ZigZagChannelMode == 1) if(hi > hiBuffer[shift]) hiBuffer[shift] = hi; 
       
         if(loValue[index][0] > 0) loBuffer[shift] = loValue[index][0];    
         if(ZigZagChannelMode == 1) if(lo < loBuffer[shift]) loBuffer[shift] = lo; 
         }
      }
   }

   if(AlertMode > 0)
   {
   bool uptrend = trend[index][1] > 0 && trend[index][2] <= 0;                  
   bool dntrend = trend[index][1] < 0 && trend[index][2] >= 0;
        
      if(uptrend || dntrend)
      {
      
         if(isNewBar(Period()))
         {
         BoxAlert(uptrend," : BUY Signal at " +DoubleToStr(Close[1],Digits)+", StopLoss on "+DoubleToStr(loValue[index][1],Digits));   
         BoxAlert(dntrend," : SELL Signal at "+DoubleToStr(Close[1],Digits)+", StopLoss on "+DoubleToStr(hiValue[index][1],Digits)); 
         }
      
      WarningSound(uptrend,SoundsNumber,SoundsPause,UpSound,Time[1]);
      WarningSound(dntrend,SoundsNumber,SoundsPause,DnSound,Time[1]);
         
         if(EmailMode > 0)
         {
         EmailAlert(uptrend,"New BUY Signal" ," : BUY Signal at " +DoubleToStr(Close[1],Digits)+", StopLoss on "+DoubleToStr(loValue[index][1],Digits),EmailsNumber); 
         EmailAlert(dntrend,"New SELL Signal"," : SELL Signal at "+DoubleToStr(Close[1],Digits)+", StopLoss on "+DoubleToStr(hiValue[index][1],Digits),EmailsNumber); 
         }
      }
   }
}



//-------------------------------------------  

int LowestBar(int len,int k,int opt)
{
   double min = 10000000;   
   
   if(len <= 0) int lobar = k;
   else   
   for (int i=k+len-1;i>=k;i--)
   {
   double lo0 = iMA(NULL,0,1,0,0,LoBandPrice,i);
   if(opt==1) double lo1 = iMA(NULL,0,1,0,0,LoBandPrice,i-1);
   if((opt==1 && (i==0 || (i > 0/*&& lo0 < lo1*/)) && lo0 <= min) || (opt==0 && lo0 <= min)) {min = lo0; lobar = i;}
   }   
   
   return(lobar);
} 

//-------------------------------------------  

int HighestBar(int len,int k,int opt)
{
   double max = -10000000;   
   
   if(len <= 0) int hibar = k;
   else
   for (int i=k+len-1;i>=k;i--)
   {
   double hi0 = iMA(NULL,0,1,0,0,UpBandPrice,i);
   if(opt==1) double hi1 = iMA(NULL,0,1,0,0,LoBandPrice,i-1);  
   if((opt==1 && (i==0 || (i > 0 /*&& hi0 > hi1*/)) && hi0 >= max) || (opt==0 && hi0 >= max)) {max = hi0; hibar = i;}
   }   

   return(hibar);
} 
 
string tf(int timeframe)
{
   switch(timeframe)
   {
   case PERIOD_M1:   return("M1");
   case PERIOD_M5:   return("M5");
   case PERIOD_M15:  return("M15");
   case PERIOD_M30:  return("M30");
   case PERIOD_H1:   return("H1");
   case PERIOD_H4:   return("H4");
   case PERIOD_D1:   return("D1");
   case PERIOD_W1:   return("W1");
   case PERIOD_MN1:  return("MN1");
   default:          return("Unknown timeframe");
   }
}         
//------------------------------------------- 

bool isNewBar(int tf)
{
   static datetime pTime;
   bool res=false;
   
   if(tf >= 0)
   {
      if (iTime(NULL,tf,0)!= pTime)
      {
      res=true;
      pTime=iTime(NULL,tf,0);
      }   
   }
   else res = true;
   
   return(res);
}

bool BoxAlert(bool cond,string text)   
{      
   string mess = " "+Symbol()+" "+TF + ":" + " " + short_name + text;
   
   if (cond && mess != prevmess)
	{
	Alert (mess);
	prevmess = mess; 
	return(true);
	} 
  
   return(false);  
}

bool Pause(int sec)
{
   if(TimeCurrent() >= preTime + sec) {preTime = TimeCurrent(); return(true);}
   
   return(false);
}

void WarningSound(bool cond,int num,int sec,string sound,datetime ctime)
{
   static int i;
   
   if(cond)
   {
   if(ctime != ptime) i = 0; 
   if(i < num && Pause(sec)) {PlaySound(sound); ptime = ctime; i++;}       	
   }
}

bool EmailAlert(bool cond,string text1,string text2,int num)   
{      
   string subj = text1 +" from " + short_name + "!!!";    
   string mess = " "+Symbol()+" "+TF + ":" + " " + short_name + text2;
   
   if (cond && mess != prevemail)
	{
	if(subj != "" && mess != "") for(int i=0;i<num;i++) SendMail(subj, mess);  
	prevemail = mess; 
	return(true);
	} 
  
   return(false);  
}	         